{prototypical one-time cypher system}
PROGRAM one_time_cipher (input, output);

USES crt;

TYPE
  datafile = FILE OF BYTE;

VAR
  plain : datafile;
  cipher : datafile;
  start : REAL;
  step  : REAL;
  user  : CHAR;
  fname : string;

  {our function, which could be anything we want it to be}
FUNCTION pseudo (x : REAL) : BYTE;
BEGIN {pseudo}
  pseudo := ROUND (200 * SIN ( (PI * x * x * x) / 180) );
END; {pseudo}

FUNCTION encipher (orig : BYTE; value : REAL) : BYTE;
BEGIN {encipher}
  IF ( (orig + pseudo (value) ) > 255) THEN
     encipher := orig + pseudo (value) - 256
  ELSE
     encipher := orig + pseudo (value);
END; {encipher}

FUNCTION decipher (orig : BYTE; value : REAL) : BYTE;
BEGIN {decipher}
  IF ( (orig - pseudo (value) ) < 0) THEN
     decipher := orig - pseudo (value) + 256
  ELSE
     decipher := orig - pseudo (value);
END; {decipher}

PROCEDURE encode;
VAR where   : byte;
    current : real;
    tempval : byte;
BEGIN {encode}
  REWRITE (cipher);
  RESET (plain);
  current := start;
  WHILE NOT EOF (plain) DO
        BEGIN {while}
        READ (plain, where);
        tempval := encipher(where, current);
        WRITE (cipher, tempval);
        current := current + step;
        END; {while}
END; {encode}

PROCEDURE decode;
VAR where   : byte;
    current : real;
    tempval : byte;
BEGIN {decode}
  REWRITE (plain);
  RESET (cipher);
  current := start;
  WHILE NOT EOF (cipher) DO
        BEGIN {while}
        READ (cipher, where);
        tempval := decipher(where, current);
        WRITE (plain, tempval);
        current := current + step;
        END; {while}
END; {decode}

BEGIN {main}
     clrscr;
     writeln('One-Time Cipher 1.00');
     writeln;
     write('(E)ncrypt or (D)ecrypt');
     user:=readkey;
     writeln;
     write('Plaintext file name: ');
     readln(fname);
     assign(plain, fname);
     write('Ciphertext file name: ');
     readln(fname);
     assign(cipher, fname);
     write('Start value: ');
     readln(start);
     write('Step value: ');
     readln(step);
     IF upcase(USER)='E' then encode;
     IF upcase(USER)='D' then decode;
     close(plain);
     close(cipher);
END. {main}
